//+------------------------------------------------------------------+
//|                                                 VolumeMinute.mq4 |
//|                                               Copyright 2012, MR |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MR"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DarkSlateGray
#property indicator_color2 Lime
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1  4
#property indicator_width2  4

//---- input parameters
extern bool displayAlert=true;
extern int AvPeriod=5;
extern int VolFaktor=2;

//--- buffers
double Buffer1[];
double Buffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
string indi_name;
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   indi_name="VolMin";
   IndicatorShortName(indi_name);
   SetIndexLabel(0,"neutral");
   SetIndexLabel(1,"high_vol");
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);

         static datetime lastAlertedAt = 0;
   //
   //
   //
   //
   //
   
   for (int i=limit; i>=0; i--)
   {
      double avVol = 0;
        for (int k=1; k<AvPeriod+1; k++) avVol += Volume[i+k];
                                         avVol /= AvPeriod*1.0;
	  
        Buffer1[i]=1;
        Buffer2[i]=0;

        //
        //
        //
        //
        //
              	     
	     if (Volume[i]>=avVol*VolFaktor)
	     {
	        Buffer1[i]=0;
	        Buffer2[i]=1;
	        if (i==0 && lastAlertedAt!=Time[0])                                   
           {
               Alert("Volume exceeded average volume  ",Symbol());                                      
               lastAlertedAt=Time[0];
           } 
	     }
	}
   return(0);
}